diff --git a/src/web100-util.c b/src/web100-util.c
index 6164c02..43db4b5 100644
--- a/src/web100-util.c
+++ b/src/web100-util.c
@@ -566,114 +944,67 @@ int web100_setbuff(int sock, web100_agent* agent, web100_connection* cn,
 
   return (0);
 }
+#endif
 
 /**
  * @param sock integer socket file descriptor indicating data recipient
- * @param pointers to local copies of web100 variables
+ * @param tcp_vars to local copies of tcp_stat variables
  * @return integer 0
- *
- *
  */
-int web100_logvars(int *Timeouts, int *SumRTT, int *CountRTT, int *PktsRetrans,
-                   int *FastRetran, int *DataPktsOut, int *AckPktsOut,
-                   int *CurrentMSS, int *DupAcksIn, int *AckPktsIn,
-                   int *MaxRwinRcvd, int *Sndbuf, int *CurrentCwnd,
-                   int *SndLimTimeRwin, int *SndLimTimeCwnd,
-                   int *SndLimTimeSender, int *DataBytesOut,
-                   int *SndLimTransRwin, int *SndLimTransCwnd,
-                   int *SndLimTransSender, int *MaxSsthresh, int *CurrentRTO,
-                   int *CurrentRwinRcvd, int *MaxCwnd, int *CongestionSignals,
-                   int *PktsOut, int *MinRTT, int count_vars, int *RcvWinScale,
-                   int *SndWinScale, int *CongAvoid, int *CongestionOverCount,
-                   int *MaxRTT, int *OtherReductions, int *CurTimeoutCount,
-                   int *AbruptTimeouts, int *SendStall, int *SlowStart,
-                   int *SubsequentTimeouts, int *ThruBytesAcked) {
-  int i;
+int tcp_stat_logvars(struct tcp_vars* vars, int count_vars) {
+#if USE_WEB100
+  int a, b;
+  for (a = 0; a < sizeof(struct tcp_vars) / sizeof(tcp_stat_var); ++a) {
+    const char* web100_name = tcp_names[a].web100_name;
+    if (web100_name == NULL)
+      continue;
+
+    for (b = 0; b < count_vars; b++) {
+      if (strcmp(web_vars[b].name, web100_name) == 0) {
+        tcp_stat_var* var = ((tcp_stat_var*) vars) + a;
+        *var = atoi(web_vars[b].value);
+        log_println(5, "Found %s : %i", web100_name, *var);
+        break;
+      }
+    }
+    if (b == count_vars) {
+      log_println(1, "WARNING: Failed to find Web100 var %s", web100_name);
+    }
+  }
+#elif USE_TCPE
+  int a, b;
+  assert(dataDumpSave);
+  for (a = 0; a < (sizeof(struct tcp_vars) / sizeof(tcp_stat_var)); ++a) {
+    const char* web10g_name = tcp_names[a].web10g_name;
+    if (web10g_name == NULL)
+      continue;
 
-  for (i = 0; i <= count_vars; i++) {
-    if (strcmp(web_vars[i].name, "Timeouts") == 0)
-      *Timeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SumRTT") == 0)
-      *SumRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CountRTT") == 0)
-      *CountRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "PktsRetrans") == 0)
-      *PktsRetrans = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "FastRetran") == 0)
-      *FastRetran = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DataPktsOut") == 0)
-      *DataPktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AckPktsOut") == 0)
-      *AckPktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurMSS") == 0)
-      *CurrentMSS = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DupAcksIn") == 0)
-      *DupAcksIn = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AckPktsIn") == 0)
-      *AckPktsIn = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxRwinRcvd") == 0)
-      *MaxRwinRcvd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "X_Sndbuf") == 0)
-      *Sndbuf = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurCwnd") == 0)
-      *CurrentCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxCwnd") == 0)
-      *MaxCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeRwin") == 0)
-      *SndLimTimeRwin = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeCwnd") == 0)
-      *SndLimTimeCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTimeSender") == 0)
-      *SndLimTimeSender = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "DataBytesOut") == 0)
-      *DataBytesOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransRwin") == 0)
-      *SndLimTransRwin = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransCwnd") == 0)
-      *SndLimTransCwnd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndLimTransSender") == 0)
-      *SndLimTransSender = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxSsthresh") == 0)
-      *MaxSsthresh = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurRTO") == 0)
-      *CurrentRTO = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurRwinRcvd") == 0)
-      *CurrentRwinRcvd = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongestionSignals") == 0)
-      *CongestionSignals = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "PktsOut") == 0)
-      *PktsOut = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MinRTT") == 0)
-      *MinRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "RcvWinScale") == 0)
-      *RcvWinScale = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SndWinScale") == 0)
-      *SndWinScale = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongAvoid") == 0)
-      *CongAvoid = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CongestionOverCount") == 0)
-      *CongestionOverCount = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "MaxRTT") == 0)
-      *MaxRTT = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "OtherReductions") == 0)
-      *OtherReductions = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "CurTimeoutCount") == 0)
-      *CurTimeoutCount = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "AbruptTimeouts") == 0)
-      *AbruptTimeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SendStall") == 0)
-      *SendStall = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SlowStart") == 0)
-      *SlowStart = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "SubsequentTimeouts") == 0)
-      *SubsequentTimeouts = atoi(web_vars[i].value);
-    else if (strcmp(web_vars[i].name, "ThruBytesAcked") == 0)
-      *ThruBytesAcked = atoi(web_vars[i].value);
+    for (b = 0; b < ARRAYSIZE(dataDumpSave->val); ++b) {
+      if (dataDumpSave->val[b].mask)
+        continue;
+      if (strcmp(tcpe_var_array[b].name, web10g_name) == 0) {
+        tcp_stat_var* var = ((tcp_stat_var*) vars) + a;
+        *var = dataDumpSave->val[b].uv32;
+        log_println(5, "Found %s : %i", web10g_name, *var);
+        break;
+      }
+    }
+    if (b == ARRAYSIZE(dataDumpSave->val)) {
+      log_println(1, "WARNING: Failed to find Web10g var %s", web10g_name);
+    }
   }
 
-  return (0);
+  vars->AckPktsOut = 0;
+  vars->Sndbuf = X_SndBuf;
+  vars->MaxCwnd = MAX(vars->MaxSsCwnd, vars->MaxCaCwnd);
+
+  tcpe_data_free(&dataDumpSave);
+  dataDumpSave = NULL;
+#endif
+  return 0;
 }
 
+#if USE_WEB100
 /**
  * Routine to read snaplog file and determine the number of times the
  * congestion window is reduced.
@@ -751,7 +1082,9 @@ int CwndDecrease(web100_agent* agent, char* logname, u_int32_t *dec_cnt,
       *inc_cnt, *dec_cnt, *same_cnt);
   return (0);
 }
+#endif  // TODO: Implement in web10g when logging is doable.
 
+#if USE_WEB100
 /**
  * Generate TCP/IP checksum for our packet
  *
@@ -939,3 +1272,4 @@ int KillHung(void) {
     return (-1);
   return (0);
 }
+#endif
diff --git a/src/web100clt.c b/src/web100clt.c
index f2e302c..42cbfd1 100644
--- a/src/web100clt.c
+++ b/src/web100clt.c
@@ -1,5 +1,7 @@
 #include "../config.h"
 
+#include <arpa/inet.h>
+#include <assert.h>
 #include <ctype.h>
 #include <errno.h>
 #include <getopt.h>
@@ -237,6 +239,26 @@ void testResults(char tests, char *testresult_str, char* host) {
 }
 
 /**
+ * Get a string representation of an ip address.
+ *
+ * @param addr A sockaddr structure which contains the address
+ * @param buf A buffer to fill with the ip address as a string
+ * @param len The length of buf.
+ */
+static void addr2a(struct sockaddr_storage * addr,char * buf, int len){
+  if (((struct sockaddr *)addr)->sa_family == AF_INET) {
+    inet_ntop(AF_INET, &(((struct sockaddr_in *)addr)->sin_addr),
+                    buf, len);
+  }
+#ifdef AF_INET6
+  else if (((struct sockaddr *)addr)->sa_family == AF_INET6) {
+    inet_ntop(AF_INET6, &(((struct sockaddr_in6 *)addr)->sin6_addr),
+                    buf, len);
+  }
+#endif
+}
+
+/**
  * This routine decodes the middlebox test results.  The data is returned
  * from the server in a specific order.  This routine pulls the string apart
  * and puts the values into the proper variable.  It then compares the values
@@ -247,14 +269,14 @@ void testResults(char tests, char *testresult_str, char* host) {
  * Client then adds
  * Server IP; Client IP.
  * @param midresult_str  String containing test results
- * @param local_addr Client IP address
- * @param peer_addr  Server IP address
+ * @param cltsock Used to get address information
  */
 
-void middleboxResults(char *midresult_str, I2Addr local_addr,
-                      I2Addr peer_addr) {
+void middleboxResults(char *midresult_str, int cltsock) {
   char ssip[64], scip[64], *str;
   char csip[64], ccip[64];
+  struct sockaddr_storage addr;
+  socklen_t addr_size = sizeof(addr);
   int mss;
   size_t tmpLen;
 
@@ -274,10 +296,19 @@ void middleboxResults(char *midresult_str, I2Addr local_addr,
 
   memset(ccip, 0, 64);
   tmpLen = 63;
-  I2AddrNodeName(local_addr, ccip, &tmpLen);
+  if (getsockname(cltsock, (struct sockaddr*) &addr, &addr_size) == -1) {
+    perror("Middlebox - getsockname() failed");
+  } else {
+    addr2a(&addr, ccip, tmpLen);
+  }
   memset(csip, 0, 64);
   tmpLen = 63;
-  I2AddrNodeName(peer_addr, csip, &tmpLen);
+  addr_size = sizeof(addr);
+  if (getpeername(cltsock, (struct sockaddr*) &addr, &addr_size) == -1) {
+    perror("Middlebox - getpeername() failed");
+  } else {
+    addr2a(&addr, csip, tmpLen);
+  }
 
   // Check if MSS modification is happening
   check_MSS_modification(TimestampsEnabled, &mss);
@@ -486,7 +517,6 @@ int main(int argc, char *argv[]) {
   int testId;  // test ID received from server
   // addresses..
   I2Addr server_addr = NULL;
-  I2Addr local_addr = NULL, remote_addr = NULL;
   char* ptr;
 #ifdef AF_INET6
 #define GETOPT_LONG_INET6(x) "46"x
@@ -854,19 +884,17 @@ int main(int argc, char *argv[]) {
     log_println(6, "resultstr = '%s'", resultstr);
   }
 
-  local_addr = I2AddrByLocalSockFD(get_errhandle(), ctlSocket, False);
-  remote_addr = I2AddrBySockFD(get_errhandle(), ctlSocket, False);
-  I2AddrFree(server_addr);
-
   strlcpy(varstr, resultstr, sizeof(varstr));
   // print test results
   testResults(tests, resultstr, host);
 
   // print middlebox test results
   if (tests & TEST_MID) {
-    middleboxResults(mid_resultstr, local_addr, remote_addr);
+    middleboxResults(mid_resultstr, ctlSocket);
   }
 
+  I2AddrFree(server_addr);
+
   // print extra information collected from web100 variables
   if ((tests & TEST_S2C) && (msglvl > 1))
     printVariables(varstr);
